MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sc::ShmMemoryGrp Class Reference

    The ShmMemoryGrp concrete class provides an implementation of

MsgMemoryGrp. More...

`#include <memshm.h>`

Inheritance diagram for sc::ShmMemoryGrp:
[legend]
Collaboration diagram for sc::ShmMemoryGrp:
[legend]

## Public Member Functions
| ShmMemoryGrp (const Ref< MessageGrp > &msg)
| ShmMemoryGrp (const Ref< KeyVal > &)
void | set_localsize (size_t)
| Set the size of locally held memory. More...
void * | localdata ()
| Returns a pointer to the local data.
void * | obtain_readwrite (distsize_t offset, int size)
| Only one thread can have an unreleased obtain_readwrite at a time. More...
void * | obtain_readonly (distsize_t offset, int size)
| This gives read access to the memory location. No locking is done.
void * | obtain_writeonly (distsize_t offset, int size)
| This gives write access to the memory location. No locking is done.
void | release_readonly (void *data, distsize_t offset, int size)
| This is called when read access is no longer needed.
void | release_writeonly (void *data, distsize_t offset, int size)
| This is called when write access is no longer needed.
void | release_readwrite (void *data, distsize_t offset, int size)
| This is called when read/write access is no longer needed. More...
void | print (std::ostream &o=ExEnv::out0()) const
| Prints out information about the object.
Public Member Functions inherited from sc::MsgMemoryGrp
| MsgMemoryGrp (const Ref< MessageGrp > &msg)
| MsgMemoryGrp (const Ref< KeyVal > &keyval)
void | sync ()
| Synchronizes all the nodes. More...
Public Member Functions inherited from sc::MemoryGrp
| MemoryGrp (const Ref< KeyVal > &)
int | me () const
| Returns who I am.
int | n () const
| Returns how many nodes there are.
size_t | localsize ()
| Returns the amount of memory residing locally on me().
distsize_t | localoffset ()
| Returns the global offset to this node's memory.
int | size (int node)
| Returns the amount of memory residing on node.
distsize_t | offset (int node)
| Returns the global offset to node's memory.
distsize_t | totalsize ()
| Returns the sum of all memory allocated on all nodes.
virtual void | activate ()
| Activate is called before the memory is to be used.
virtual void | deactivate ()
| Deactivate is called after the memory has been used.
virtual void | sum_reduction (double *data, distsize_t doffset, int dsize)
virtual void | sum_reduction_on_node (double *data, size_t doffset, int dsize, int node=-1)
virtual void * | malloc_local (size_t nbyte)
| Allocate data that will be accessed locally only. More...
virtual double * | malloc_local_double (size_t ndouble)
virtual void | free_local (void *data)
| Free data that was allocated with malloc_local_double. More...
virtual void | free_local_double (double *data)
virtual void | catchup ()
| Processes outstanding requests. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members
Static Public Member Functions inherited from sc::MemoryGrp
static MemoryGrp * | initial_memorygrp (int &argc, char **argv)
| Create a memory group. More...
static MemoryGrp * | initial_memorygrp ()
static void | set_default_memorygrp (const Ref< MemoryGrp > &)
| The default memory group contains the primary memory group to be used by an application. More...
static MemoryGrp * | get_default_memorygrp ()
| Returns the default memory group. More...
Protected Member Functions inherited from sc::MemoryGrp
void | obtain_local_lock (size_t start, size_t fence)
void | release_local_lock (size_t start, size_t fence)
Protected Attributes inherited from sc::MsgMemoryGrp
Ref< MessageGrp > | msg_

## Detailed Description

    The ShmMemoryGrp concrete class provides an implementation of

MsgMemoryGrp.

It uses SYSV IPC to provided shared memory in a system that provide shared memory in hardware. It is very fast and reliable.

## Member Function Documentation

void* sc::ShmMemoryGrp::obtain_readwrite | ( | distsize_t | offset,
|  | int | size
| ) |  |
| virtual

Only one thread can have an unreleased obtain_readwrite at a time.

The actual memory region locked can be larger than that requested. If the memory region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implements sc::MemoryGrp.

void sc::ShmMemoryGrp::release_readwrite | ( | void * | data,
|  | distsize_t | offset,
|  | int | size
| ) |  |
| virtual

This is called when read/write access is no longer needed.

The memory will be unlocked.

Implements sc::MemoryGrp.

void sc::ShmMemoryGrp::set_localsize | ( | size_t |  | ) |
| virtual

Set the size of locally held memory.

When memory is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Reimplemented from sc::MsgMemoryGrp.

The documentation for this class was generated from the following file:

- memshm.h